<?php

declare(strict_types=1);

namespace Dedi\SyliusOrderStatusHistoryPlugin\Twig;

use Twig\Extension\AbstractExtension;
use Twig\TwigFunction;

class OrderStatesExtension extends AbstractExtension
{
    public function getFunctions(): array
    {
        return [
            new TwigFunction('dedi_order_status_history_payment_states', [$this, 'getPaymentStates']),
            new TwigFunction('dedi_order_status_history_shipping_states', [$this, 'getShippingStates']),
            new TwigFunction('dedi_order_status_history_order_states', [$this, 'getOrderStates']),
        ];
    }

    public function getPaymentStates(): array
    {
        return [
            'cart' => ['icon' => 'adjust', 'color' => 'grey'],
            'authorized' => ['icon' => 'check', 'color' => 'orange'],
            'awaiting_payment' => ['icon' => 'clock', 'color' => 'grey'],
            'cancelled' => ['icon' => 'ban', 'color' => 'red'],
            'paid' => ['icon' => 'check', 'color' => 'green'],
            'partially_authorized' => ['icon' => 'check', 'color' => 'yellow'],
            'partially_paid' => ['icon' => 'adjust', 'color' => 'olive'],
            'partially_refunded' => ['icon' => 'reply', 'color' => 'violet'],
            'refunded' => ['icon' => 'reply all', 'color' => 'purple'],
        ];
    }

    public function getShippingStates(): array
    {
        return [
            'cart' => ['icon' => 'adjust', 'color' => 'grey'],
            'cancelled' => ['icon' => 'ban', 'color' => 'red'],
            'shipped' => ['icon' => 'plane', 'color' => 'green'],
            'partially_shipped' => ['icon' => 'adjust', 'color' => 'yellow'],
            'ready' => ['icon' => 'clock', 'color' => 'blue'],
        ];
    }

    public function getOrderStates(): array
    {
        return [
            'cart' => ['icon' => 'adjust', 'color' => 'grey'],
            'cancelled' => ['icon' => 'ban', 'color' => 'red'],
            'new' => ['icon' => 'inbox', 'color' => 'blue'],
            'fulfilled' => ['icon' => 'check', 'color' => 'green'],
        ];
    }
}
